#include "bmsfel_p.h"

//################################################
// `l1

//////////////////////////////////////////////////
// RXgN^Q
BmsChannel::BmsChannel() : BmsBuffer( CHANNEL_LENGTH_DEFAULT ) {
  this->set_channel_number( BmsWord( 0 ) );
  this->same_next = NULL_CHANNEL;
  this->next = NULL_CHANNEL;
}

BmsChannel::BmsChannel( BmsWord channel_word ) : BmsBuffer( CHANNEL_LENGTH_DEFAULT ) {
  this->set_channel_number( channel_word );
  this->same_next = NULL_CHANNEL;
  this->next = NULL_CHANNEL;
}

// fXgN^
BmsChannel::~BmsChannel() {
  if ( this->same_next != NULL_CHANNEL ) { delete this->same_next; }
}

//////////////////////////////////////////////////
// `lpXg\֐
// Ⴄ`lȂo^falseԂ
bool BmsChannel::set_same_next( BmsChannel *same_next ) {
  bool return_value;
  if ( same_next->get_channel_number() == this->get_channel_number() ) {
    this->same_next = same_next;
    return_value = true;
  }
  else {
    return_value = false;
  }
  return return_value;
}

BmsChannel *BmsChannel::get_same_next() const {
  return this->same_next;
}

//////////////////////////////////////////////////
// `lp`Xg
void BmsChannel::set_next( BmsChannel *next ) {
  this->next = next;
}

BmsChannel *BmsChannel::get_next() const {
  return this->next;
}

//////////////////////////////////////////////////
// setn
void BmsChannel::set_channel_number( BmsWord channel_word ) {
  this->channel_number = channel_word;
}

//////////////////////////////////////////////////
// getn
// |C^ł͂Ȃ̂Œ
BmsWord BmsChannel::get_channel_number() const {
  return this->channel_number;
}

//////////////////////////////////////////////////
// ȍ~̓[eBeBn


//////////////////////////////////////////////////
// BmsBuffer̊֐̂length𒴂zg֐
BmsWord BmsChannel::overwrite( int nth, BmsWord obj ) {
  this->extend_array_over( nth );
  return this->BmsBuffer::overwrite( nth, obj );
}
int BmsChannel::merge( BmsBuffer *input_buffer ) {
  this->extend_array_over( input_buffer->get_length() );
  return this->BmsBuffer::merge( input_buffer );
}
int BmsChannel::merge( int nth, BmsBuffer *input_buffer ) {
  this->extend_array_over( nth + input_buffer->get_length() );
  return this->BmsBuffer::merge( nth, input_buffer );
}
int BmsChannel::push_in( BmsBuffer *input_buffer ) {
  this->extend_array_over( input_buffer->get_length() );
  return this->BmsBuffer::push_in( input_buffer );
}
int BmsChannel::push_in( int nth, BmsBuffer *input_buffer ) {
  this->extend_array_over( nth + input_buffer->get_length() );
  return this->BmsBuffer::push_in( nth, input_buffer );
}

// z(BAR_LENGTH_DEFAULT * 10 * n > nth)g֐
int BmsChannel::extend_array_over( int nth ) {
  if ( nth >= this->length ) {
    int new_length;
    for ( new_length = this->length; new_length <= nth; new_length += CHANNEL_EXTEND_LENGTH ) {}
    BmsWord *new_array = new BmsWord[new_length];
    for ( int i = 0; i < this->length; ++i ) {
      new_array[i] = this->at( i );
    }
    delete [] this->obj_array;
    this->obj_array = new_array;
    this->length = new_length;
  }
  return this->length;
}
